<script lang="ts">
  import { useNavigate } from 'svelte-navigator';
  import { KANBAN_BASE_PATH } from 'constants/paths';
  import { mutation } from '@urql/svelte';
  import {
    CreateKanbanDocument,
    type CreateKanbanMutation,
    type CreateKanbanMutationVariables,
  } from 'generated/graphql';
  import generateId from 'utils/generateId';
  import TextInput from 'components/TextInput';
  import {
    isAuthenticated,
    userId,
  } from 'stores/authStore';
  import SignInButton from 'components/SignInButton';

  const createKanbanMutation = mutation<CreateKanbanMutation, CreateKanbanMutationVariables>({ query: CreateKanbanDocument });
  
  let name = '';

  const navigate = useNavigate();

  const handleCreateKanban = async () => {
    if (!name) return;
    const kanbanShortId = generateId();
    const createKanbanRes = await createKanbanMutation({
      authorId: $userId,
      data: {
        name,
        shortId: kanbanShortId,
      },
    });
    if (createKanbanRes.error) {
      console.error(createKanbanRes.error);
      return;
    }
    navigate(`${KANBAN_BASE_PATH}/${kanbanShortId}`);
  };
</script>

<div class="p-4 rounded-lg flex flex-col max-w-xl w-full items-center bg-white dark:bg-gray-800 shadow-sm dark:shadow-none dark:border dark:border-gray-700">
  <h2 class="dark:text-white text-3xl pb-3 font-semibold">Start new kanban</h2>
    <form class="w-full flex flex-col items-center" on:submit|preventDefault={handleCreateKanban}>
      <TextInput
        bind:value={name}
        id="name"
        placeholder="Name your kanban"
        required="true"
        class="p-2 text-xl mt-8"
      />
      <button
        type="submit"
        disabled={!$isAuthenticated}
        class="text-white w-1/4 flex justify-center text-xl  focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium
          rounded-lg text-md px-5 py-2 mt-8 text-center inline-flex items-center  dark:focus:ring-blue-800
          {$isAuthenticated ? 'bg-gradient-to-r from-purple-600 to-blue-500' : 'bg-gray-400 dark:bg-gray-500 cursor-not-allowed'}"
        >
        Start
      </button>
      {#if !$isAuthenticated}
        <SignInButton class="text-md font-medium px-5 py-2 w-1/4 justify-center mt-3" />
      {/if}
    </form>
</div>